const SocketService = require('../service/SocketService');
const UpdaterLogger = require('../logs/UpdaterLogger');

class LogController {
  async setUpdaterLog(file, param) {
    const { CDFILIAL, CDCAIXA } = param;
    const UpdaterSocketClass = SocketService.getUpdaterSocket();
    const downloadLogRoomName = UpdaterSocketClass.getDownloadLogRoom(CDFILIAL, CDCAIXA, 'txt');
    const downloadLogRoom = UpdaterSocketClass.getRoom(downloadLogRoomName);

    if (file && downloadLogRoom) {
      this.updaterLog = {
        file,
        param
      };
      downloadLogRoom.emit('downloadLogResult', { error: false, message: 'SUCCESS_UPLOAD_LOG', param });
    }
  }

  async getUpdaterLog(){
    return this.updaterLog;
  }

  clearLogFile() {
    this.updaterLog = {};
  }

  async setLogZipFile(file, param) {
    try {
      const { CDFILIAL, CDCAIXA, PRODUCT } = param;
      const UpdaterSocketClass = SocketService.getUpdaterSocket();
      const downloadLogRoomName = UpdaterSocketClass.getDownloadLogRoom(CDFILIAL, CDCAIXA, 'zip');
      const roomDownloadLog = UpdaterSocketClass.getRoom(downloadLogRoomName);

      if (file && roomDownloadLog) {
        const { UPDATER_LOG_SERVER } = process.env;
        
        const { fileName, error, message } = await UpdaterLogger.writeZip(CDFILIAL, CDCAIXA, PRODUCT, Buffer.from(file));
        if(error) {
          roomDownloadLog.emit('downloadLogResult', {error, message, param});
        } else {
          param.downloadUrl = `${UPDATER_LOG_SERVER}/${fileName}`
          roomDownloadLog.emit('downloadLogResult', { error: false, message: 'UPLOAD_ZIPLOG_SUCCESS', param });
        }
        
      }
    } catch (error) {
      SystemLogger.error(error);
    }
  }

}

module.exports = new LogController();